import ProdArrows
import ProdArrowInstances

loopThroughLeft :: ArrowLoop a b => a (b c d) (b e f) -> a f d -> a c e
loopThroughLeft f g = proc i -> do rec ii' >- f      -> oo'
                                       o'   >- g      -> i'  
                                   o        >- arr id 

loopThroughLeft' f g = proc i -> do rec o'   >- g      -> i'   
                                        ii' >- f      -> oo' 
                                    o        >- arr id

loopThroughRight f g = proc i -> do rec i'i >- f      -> o'o 
                                        o'   >- g      -> i'   
                                    o        >- arr id

loopThroughRight' f g = proc i -> do rec o'   >- g      -> i'   
                                         i'i >- f      -> o'o 
                                     o        >- arr id

addA f g = proc x -> do
   x >- f -> y
   x >- g -> z
   y + z >- arr id

addA' f g
  = ((arr id &&& f) >>>
       (asnd &&& (afst >>> g)) >>> combine >>> arr (\ (x, y) -> x + y))

--a &&& b  >>>  c *** d = (a >>> c) &&& (b >>> d)
--a &&& b  >>>  (afst >>> c) &&& (asnd >>> d) = (a >>> c) &&& (b >>> d)

test' f g h
  = ((arr id &&&
        (loop (asnd >>> f >>> (arr id &&& h) >>> (arr id &&& asnd))))
       >>> g)

test f g h = proc x -> do

             rec z >- f       -> y
                 y >- h       -> z
             x  (y  z) >- g

{-
cmd ::=  exp -< exp
    |    cmd op cmd
    |    \ p -> cmd
    |    let ds in cmd
    |    do {stmt*; cmd}
    |    form exp cmd ... cmd

stmt ::= let decls
     |   p <- cmd
     |   rec { stmt* }

   p <- exp -< exp
   p <- cmd op cmd
   p <- let ds in cmd
   p <- do {smts*; cmd}
   p <- form exp cmd ... cmd

-- Left to right

cmd ::=  exp >- exp
    |    cmd op cmd
    |    \ p -> cmd
    |    let ds in cmd
    |    do {stmt*; cmd}
    |    form exp cmd ... cmd

stmt ::= let decls
     |   cmd -> p
     |   rec { stmt* }

     do
       x >- f -> y
       y+1 >- g -> z
-}

