import ProdArrows
import ProdArrowInstances

newtype MaybeArrow a b = MA (a -> Maybe b)
deMA (MA f) = f

instance Arrow MaybeArrow where
    arr f = MA (Just . f)
    MA f >>> MA g = MA (\x -> f x >>= g)

instance ProdArrow MaybeArrow (,) where
   MA f &&& MA g = MA (\x -> f x >>= \a -> g x >>= \b -> return (a,b))
   afst = MA (Just . fst)
   asnd = MA (Just . snd)

instance ArrowUnit MaybeArrow where aunit = MA (const (Just ()))

instance ArrowApply MaybeArrow (,) where 
  app = MA (\ ~(MA f,x) -> f x)

instance ArrowLoop MaybeArrow (,) where
  loop (MA f) = MA (\a -> let mf = f (a,r)
                              (b,r) = case mf of Just b -> b
                                                 _ -> error "MaybeArrow.loop"
                          in Just b)

a1 x = proc h  x -> do
       MA (const (Just 4)) >- arr id -> h1
       x >- h                        -> x1
       h1  x1 >- arr id

a2 x = proc h  x -> do
       x >- h                        -> x1
       MA (const (Just 4)) >- arr id -> h1
       h1  x1 >- arr id

t1 = proc () -> do
        rec MA (const (Just 4)) >- arr id -> h
            x >- h                        -> x
        x >- arr id
     
t2 = proc () -> do
        rec x >- h                        -> x
            MA (const (Just 4)) >- arr id -> h
        x >- arr id


