module Main where
import ProdArrows
import ProdArrowInstances
 
newtype MaybeArrow a b = MA (a -> Maybe b)
deMA (MA f) = f
 
instance Arrow MaybeArrow where
	arr f = MA (Just . f)
	MA f >>> MA g = MA (\ x -> f x >>= g)
 
instance ProdArrow MaybeArrow (,) where
	MA f &&& MA g
	  = MA (\ x -> f x >>= \ a -> g x >>= \ b -> return (a, b))
	afst = MA (Just . fst)
	asnd = MA (Just . snd)
 
instance ArrowUnit MaybeArrow where
	aunit = MA (const (Just ()))
 
instance ArrowApply MaybeArrow (,) where
	app = MA (\ ~(MA f, x) -> f x)
 
instance ArrowLoop MaybeArrow (,) where
	loop (MA f)
	  = MA
	      (\ a ->
		 let mf = f (a, r)
		     (b, r)
		       = case mf of
			     Just b -> b
			     _ -> error "MaybeArrow.loop"
		   in Just b)
a1 x = ((aunit >>> arr (\ () -> MA (const (Just 4)))) &&& app)
a2 x
  = (app >>>
       ((aunit >>> arr (\ () -> MA (const (Just 4)))) &&& arr id) >>>
	 arr id)
t1
  = (loop
       (asnd >>>
	  ((aunit >>> arr (\ () -> MA (const (Just 4)))) &&& arr id) >>>
	    arr id >>> app >>> (arr id &&& arr id)))
t2
  = (loop
       (asnd >>>
	  (asnd &&& afst) >>>
	    app >>>
	      (arr id &&& (aunit >>> arr (\ () -> MA (const (Just 4))))) >>>
		(afst &&& arr id)))
