import ProdArrows
import ProdArrowInstances

add f g = proc a -> do
    a >- f -> x
    a >- g -> y
    x + y >- arr id

a f = proc x  y -> x + 1 >- y

mdiagram :: Monad m => (a -> m c) -> ((c,b) -> m d) -> (a,b) -> m (c,d)
mdiagram f g = \ (a,b) -> do
    c <- f a
    d <- g (c,b)
    return (c,d)

test :: ProdArrow ac (prod) => 
        ac a c -> ac (prod c b) d -> ac (prod a b) (prod c d)
test f g = proc a  b -> do
               a >- f     -> c
               c  b >- g -> d
               c  d >- arr id

{-

test f g h = proc x -> do
             rec y <- f -< (x,z)
                 z <- g -< y
             h -< (z,y)


test f g
x       = returnA &&& (arr (\ x -> x + 1) >>> f) >>>           (x,y)
         returnA &&& (asnd >>> arr (\ y -> y + 2) >>> g) >>>   ((x,y),z)
         (asnd >>> afst) &&& (asnd >>> asnd)
            >>> combine >>> arr (\ (y, z) -> z + y) >>> g


test f g
  = (((returnA &&& (arr (\ x -> x + 1) >>> f)) >>> afst &&& asnd))
       >>> (combine >>> (arr (\ (x, y) -> x + y) >>> g)))
  = (((returnA &&& (arr (\ x -> x + 1) >>> f))))
       >>> (combine >>> (arr (\ (x, y) -> x + y) >>> g)))




u `bind` f = (returnA &&& u) >>> f

proc p -> form e c1 ... cn = e (proc p -> c1) ... (proc p -> cn)
proc p -> c1 `op` c2       = proc p -> form op c1 c2
proc p -> \\ p' -> c       = proc (p,p') -> c


proc x -> do {y <- c1; c2} = proc x -> c1 `bind` \\ y -> c2
                           = proc x -> form bind c1 (\\ y -> c2)
                           = bind (proc x -> c1) (proc x -> \\y -> c2)
                           = bind (proc x -> c1) (proc (x,y) -> c2)
                           = (returnA &&& (proc x ->c1)) >>> (proc (x,y) -> c2)
            


addA :: Arrow a => a b Int -> a b Int -> a b Int
addA f g = proc x -> do
		y <- f -< x
		z <- g -< x
		returnA -< y + z

while :: ArrowChoice a => a b Bool -> a b () -> a b ()
while p s = proc x -> do
		b <- p -< x
		if b then do
				s -< x
				while p s -< x
			else
				returnA -< ()
-}
