-- -*- haskell-hugs-program-args: ("+." "-98") -*-
module ProdArrows where

class Arrow a where
  arr :: (b -> c) -> a b c
  (>>>) :: a b c -> a c d -> a b d

returnA :: Arrow a => a x x
returnA = arr id

class Arrow a => ArrowUnit a where
  aunit :: a b ()

class Arrow a => ProdArrow a prod | a -> prod where
  (&&&) :: a b c -> a b c' -> a b (prod c c')
  afst :: a (prod b c) b
  asnd :: a (prod b c) c
  combine :: a (prod b c) (b,c)

(***) :: ProdArrow a prod => a b c -> a b' c' -> a (prod b b') (prod c c')
f *** g = (afst >>> f) &&& (asnd >>> g)

first :: ProdArrow a prod => a b c -> a (prod b d) (prod c d)
first f = f *** arr id

second :: ProdArrow a prod => a b c -> a (prod d b) (prod d c)
second f = arr id *** f

class ProdArrow a prod => ArrowApply a prod where
  app :: a (prod (a b c) b) c

class ProdArrow a prod => ArrowLoop a prod where
  loop :: a (prod b d) (prod c d) -> a b c

class Arrow a => ArrowChoice a where
  (|||) :: a b c -> a b' c -> a (Either b b') c

ainl :: Arrow a => a b (Either b c)
ainl = arr Left
ainr :: Arrow a => a b (Either c b)
ainr = arr Right

(+++) :: ArrowChoice a => a b c -> a b' c' -> a (Either b b') (Either c c')
f +++ g = (f >>> ainl) ||| (g >>> ainr)

right :: ArrowChoice a => a b c -> a (Either d b) (Either d c)
right f = arr id +++ f

left  :: ArrowChoice a => a b c -> a (Either b d) (Either c d)
left f = f +++ arr id
